#ifndef PARTICLE_H
#define PARTICLE_H

// Ensure compatibility between host and device compilers
#ifdef __CUDACC__
#define ALIGN(n) __align__(n)
#else
#define ALIGN(n) __attribute__((aligned(n)))
#endif

// Define the Particle struct
struct ALIGN(16) Particle {
    float x;
    float y;
    float z;
    int hash;       // 16 bytes so far
    float vx;
    float vy;
    float vz;
    float density;   // 32 bytes so far
    float pressure;   // 48 bytes total
    float ax;
    float ay;
    float az;
};

#endif // PARTICLE_H
