// kernels_cuda.h
#ifndef KERNELS_CUDA_H
#define KERNELS_CUDA_H

#include <cuda_runtime.h>
#include <cuda_gl_interop.h>

extern const int NUM_PARTICLES;

void updateParticles(float deltaTime);
void registerVBOWithCUDA(unsigned int vbo);
void unregisterVBOFromCUDA();
void initializeConstants();

void initializeDeviceArrays(
    const float3* h_positions,
    const float3* h_velocities,
    int numParticles
);

void cleanupDeviceArrays();

#endif // KERNELS_CUDA_H
