#version 330 core

layout(location = 0) in vec3 aPosition;

uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
uniform mat4 projectionMatrix;

uniform float pointRadius;  // Point size in world space
uniform float pointScale;

out vec3 vEyeSpacePos; // Output to fragment shader

void main()
{
    vec4 worldPos = modelMatrix * vec4(aPosition, 1.0);
    vec4 eyePos = viewMatrix * worldPos;
    vEyeSpacePos = eyePos.xyz;

    float dist = length(eyePos.xyz);
    gl_PointSize = pointRadius * (pointScale / dist);

    gl_Position = projectionMatrix * eyePos;
}
