#version 330 core

layout(location = 0) in vec3 aPosition;  // Vertex position

uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
uniform mat4 projectionMatrix;

uniform float pointRadius;  // Point size in world space
uniform float pointScale;

void main()
{
    vec4 eyePos = viewMatrix * modelMatrix * vec4(aPosition, 1.0);
    //vEyePosition = eyePos.xyz;

    // Calculate distance from the camera
    float dist = length(eyePos.xyz);

    // Calculate window-space point size
    gl_PointSize = pointRadius * (pointScale/dist); // Fixed point size for testing

    vec4 random = projectionMatrix * viewMatrix * vec4(aPosition, 1.0);
    vec3 pos = aPosition;
    pos.z=0;
    //gl_Position = vec4(pos, 1.0);
    gl_Position = projectionMatrix * eyePos;
    //gl_Position = random;
    //projectionMatrix * eyePos;
}
