#version 330 core

in vec3 vEyeSpacePos;

uniform float sphereRadius;
uniform float thicknessMass;
// We only need one color channel, 
// but OpenGL still expects a vec4 out of the fragment shader.
out vec4 FragColor;

void main()
{
    // Convert gl_PointCoord from [0,1] to [-1,1]
    vec2 texCoord = gl_PointCoord * 2.0 - 1.0;
    float r2      = dot(texCoord, texCoord);

    // Discard fragments outside the circle
    if (r2 > 1.0)
        discard;

    // For thickness: each particle in this pixel adds some amount.
    float thicknessIncrement = thicknessMass;

    // Output that in the red channel. Using GL32F only reed chanele sotred  
    FragColor = vec4(thicknessIncrement, 0.0, 0.0, 1.0);
}
