// helper_macros.h

#ifndef HELPER_MACROS_H
#define HELPER_MACROS_H

#define FOREACH_NEIGHBOR_CELL_BEGIN(cellIndex, gridSizeX, gridSizeY, gridSizeZ, neighborCellIdx) \
    do { \
        /* Compute cell coordinates */ \
        int cellX = cellIndex % gridSizeX; \
        int cellY = (cellIndex / gridSizeX) % gridSizeY; \
        int cellZ = cellIndex / (gridSizeX * gridSizeY); \
        \
        /* Iterate over neighboring cells */ \
        for (int dz = -1; dz <= 1; ++dz) { \
            int nz = cellZ + dz; \
            if (nz < 0 || nz >= gridSizeZ) continue; \
            for (int dy = -1; dy <= 1; ++dy) { \
                int ny = cellY + dy; \
                if (ny < 0 || ny >= gridSizeY) continue; \
                for (int dx = -1; dx <= 1; ++dx) { \
                    int nx = cellX + dx; \
                    if (nx < 0 || nx >= gridSizeX) continue; \
                    \
                    /* Compute neighbor cell index */ \
                    neighborCellIdx = nx + ny * gridSizeX + nz * gridSizeX * gridSizeY; \
                    /* User-defined code starts here */

#define FOREACH_NEIGHBOR_CELL_END() \
                } \
            } \
        } \
    } while(0)

#endif // HELPER_MACROS_H
