#ifndef SPATIAL_HASH_NBSEARCH_KERNELS_H
#define SPATIAL_HASH_NBSEARCH_KERNELS_H

namespace FluidSimulationGPU {

__global__ void computeCellIndices(float3* positions, unsigned int* cellIndices, int numParticles, float3 gridMin, float3 gridCellSize, int gridSizeX, int gridSizeY, int gridSizeZ);
__global__ void reorderData(unsigned int* particleIndices, float3* positions, float3* velocities, float3* positions_sorted, float3* velocities_sorted, int numParticles);
__global__ void findCellStartEnd(unsigned int* cellIndices, unsigned int* cellStart, unsigned int* cellEnd, int numParticles);
void neighbourHoodSearch(int nParticles, float3* d_pos, float3* d_vel, float3* d_posSorted, float3* d_velSorted, unsigned int* d_cellIndc, unsigned int* d_parIndc, unsigned int* d_cEnd, unsigned int* d_cStart, const int bpg, const int tpb, int &gridSizeX, int &gridSizeY, int &gridSizeZ);

} // namespace FluidSimulationGPU

#endif // SPATIAL_HASH_NBSEARCH_KERNELS_H
