//#include "include/FluidConfig.h"
#include "include/FluidRenderer.h"
#include "include/FluidSimulation.h"
#include "Camera.h"

namespace FluidSimulation
{
    struct appSettings {
        int width;
        int height;
    };

    //FluidConfig fluidConfig;


    class FluidSimulatorApp
    {
    private:
        appSettings* m_appsettings;

        Camera* m_camera;
        FluidRenderer* m_fluidRenderer;
        FluidSimulation* m_fluidSimulation;
         
        bool m_updatePhysics;
        RenderStage selectedStage = RenderStage::ScreenSpacedRender;
    
        void RenderControlPannel();
        void RenderFluidView();
        void FluidParameterControl();
        void RenderParameterControl();
    
    public:
        FluidSimulatorApp(appSettings* appSettings);
        ~FluidSimulatorApp();
        
        void Render();

        Camera* getCamera() const { return m_camera; }
        FluidRenderer* getRenderer() const { return m_fluidRenderer; };
    };
    
    FluidSimulatorApp* creatFluidSimulatorApp(appSettings* settings);
}