// ImGuiManager.h
#ifndef IMGUI_MANAGER_H
#define IMGUI_MANAGER_H

#include <GLFW/glfw3.h>
#include "imgui.h"
#include "include/FluidConfig.h"

class ImGuiManager {
public:
    // Constructor initializes ImGui
    ImGuiManager(GLFWwindow* window, FluidConfig& config);

    // Destructor cleans up ImGui
    ~ImGuiManager();

    // Starts a new ImGui frame
    void newFrame();

    // Renders ImGui draw data
    void render();

    // Provides access to ImGuiIO
    ImGuiIO& getIO();

    // Function to create the Controls window
    void createControlsWindow();

    // Function to create the FPS graph
    void createFrameStatsWindow();

    // Function to create the FBO selection window
    void createFBOSelectionWindow();

private:
    FluidConfig& fluidConfig; // Reference to fluid configuration
};

#endif // IMGUI_MANAGER_H
