// spawn_particles.h
#ifndef SPAWN_PARTICLES_H
#define SPAWN_PARTICLES_H

#include <vector>
#include <cuda_runtime.h> // for float3
#include "SimulationMode.h"

namespace FluidSimulation {

void createBoundaryParticles(
    std::vector<float3> &boundary_positions,
    std::vector<float3> &boundary_velocities, 
    int boundaryLayers, 
    float spacing
);

void initParticles( 
    std::vector<float3> &h_positions,
    std::vector<float3> &h_velocities,
    const int NUM_PARTICLES,
    const float GRID_SPACING,
    SimulationMode mode
);
}
#endif // SPAWN_PARTICLES_H