// constants.h
#ifndef CONSTANTS_H
#define CONSTANTS_H

const float h_BOUND_X_MIN = -6.0f;
const float h_BOUND_X_MAX = 12.0f;
const float h_BOUND_Y_MIN = 0.0f;
const float h_BOUND_Y_MAX = 10.0f;
const float h_BOUND_Z_MIN = -4.0f;
const float h_BOUND_Z_MAX = 4.0f;

const float h_GAS_CONSTANT = 0.02f;
const float h_VISCOSITY = 0.04f;
const float h_surface_tenns_coef = 0.0f;

const float h_PARTICLE_MASS = 0.01f;
const float h_REST_DENSITY = 600.0f;

const float h_PI = 3.14159265358979323846f;
const float h_H = 0.20f; // Smoothing radius

const int NUM_PARTICLES = 200000;

// Rendner parameters

const float h_POINT_SCALE = 14.0f;
const float h_POINT_RADIUS = 22.0f;

const float h_SPHERE_RADIUS = 0.05f;

const float h_worldRadiusMeters  = 0.4f;   // e.g. 2 cm smoothing in real space
const float h_maxPixelRadius     = 60.0f;   // clamp for performance
const float h_sigmaSpatialFactor = 10.0f;   // controls the spatial falloff in the blur loop
const float h_sigmaR             = 4.0f;    // range weight exponent
const float h_depthThresh        = 0.2f;    // bilateral threshold for ignoring big depth jumps

const float h_thicknessMass = 0.15f;
const int h_thickBlurrRadius = 24;
const float h_absorbtionR = 0.08f;
const float h_absorbtionG = 0.03f;
const float h_absorbtionB = 0.02f;
const float h_alphaScale = 3.4f;

const float h_shininess = 82.0f;

// fresnel parameters
const float h_fresnelPower = 2.0f;
const float h_fresnelScale = 0.5f;
const float h_fresnelBias  = 0.1f;

const float3 h_fluidColor = {0.2f, 0.7f, 1.0f};

#endif // CONSTANTS_H
